## mingw-w64-munt-mt32emu-2.7.1-1.src.tar.zst

=== mt32emu_win32drv_setup/infinstall/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(mt32emu_infinstall CXX C)

# We resort to rely on a non-public API of libwdi to make use of the driver signing function.
# Sadly, the public API isn't very suitable for the purpose, so we require source distribution
# at a particular version.
set(libwdi_VERSION_REQUIRED 1.3.1)
find_path(libwdi_SRC_PATH configure.ac)
if(libwdi_SRC_PATH AND EXISTS ${libwdi_SRC_PATH}/configure.ac AND EXISTS ${libwdi_SRC_PATH}/libwdi/pki.c)
  message(STATUS "Found libwdi at ${libwdi_SRC_PATH}, checking version...")
  file(STRINGS ${libwdi_SRC_PATH}/configure.ac libwdi_SRC_ID LIMIT_COUNT 1)
  string(REGEX MATCH "^AC_INIT\\(\\[libwdi\\], \\[([.0-9]+)\\]" libwdi_SRC_ID ${libwdi_SRC_ID})
  set(libwdi_SRC_VERSION ${CMAKE_MATCH_1})
endif()
if(NOT libwdi_SRC_VERSION VERSION_EQUAL libwdi_VERSION_REQUIRED)
  message(FATAL_ERROR "Need libwdi ${libwdi_VERSION_REQUIRED} source package, download from
  https://github.com/pbatard/libwdi/releases/tag/v${libwdi_VERSION_REQUIRED}")
endif()
include_directories(${libwdi_SRC_PATH}/msvc)

set(${PROJECT_NAME}_SOURCES
  infinstall.cpp
  pki_helper.cpp
  ${libwdi_SRC_PATH}/libwdi/pki.c
)

if(MSVC_IDE)
  set_source_files_properties(infinstall.cpp pki_helper.cpp
    PROPERTIES COMPILE_FLAGS -Yu
  )
  set_source_files_properties(stdafx.cpp
    PROPERTIES COMPILE_FLAGS -Yc
  )
  list(APPEND ${PROJECT_NAME}_SOURCES stdafx.cpp)
endif()

if(CMAKE_CL_64)
  set(EXE_ARCH_SUFFIX _x64)
endif()

add_definitions(
  -D_CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES=1
  -D_CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES_COUNT=1
  -D_CRT_SECURE_NO_WARNINGS
)
add_executable(infinstall ${${PROJECT_NAME}_SOURCES})
target_link_libraries(infinstall newdev.lib SetupAPI.Lib)
set_target_properties(infinstall
  PROPERTIES
    LINK_FLAGS "/ENTRY:mainCRTStartup /MANIFESTUAC:level='requireAdministrator' /SUBSYSTEM:WINDOWS"
    OUTPUT_NAME infinstall${EXE_ARCH_SUFFIX}
)

=== PKGBUILD ===
# Maintainer: Some One <some.one@some.email.com>

_realname=munt-mt32emu
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.7.1
pkgrel=1
pkgdesc="mt32emu is a C/C++ library which allows to emulate (approximately) the Roland MT-32, CM-32L and LAPC-I synthesiser modules. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://munt.sourceforge.io/"
license=('spdx:LGPL-2.1-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-cc"
)
source=("https://github.com/munt/munt/archive/refs/tags/libmt32emu_${pkgver//./_}.tar.gz")
sha256sums=('e4524d52d6799a4e32a961a2e92074f14adcb2f110a4e7a06bede77050cfdaf4')

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      ../munt-libmt32emu_${pkgver//./_}/mt32emu

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .
  install -Dm644 ${srcdir}/munt-libmt32emu_${pkgver//./_}/mt32emu/COPYING.LESSER.txt ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
